<?php

if (!defined('ABSPATH'))
    die('Restricted Access');

class JSSTuploads {

    private $ticketid;
    private $articleid;
    private $downloadid;
    private $categoryid;
    private $staffid;
    private $uploadfor;

    function jssupportticket_upload_dir( $dir ) {
        $form_request = JSSTrequest::getVar('form_request');
        if($form_request == 'jssupportticket' OR $this->uploadfor == 'agent'){
            $datadirectory = jssupportticket::$_config['data_directory'];
            $path = $datadirectory . '/attachmentdata';

            $foldername = '';

            if($this->uploadfor == 'ticket'){
                $path = $path . '/ticket';
                $query = "SELECT attachmentdir FROM `".jssupportticket::$_db->prefix."js_ticket_tickets` WHERE id = ".$this->ticketid;
                $foldername = jssupportticket::$_db->get_var($query);
            }elseif($this->uploadfor == 'article'){
                $path = $path . '/articles/article_'.$this->articleid;
            }elseif($this->uploadfor == 'download'){
                $path = $path . '/downloads/download_'.$this->downloadid;
            }elseif($this->uploadfor == 'category'){
                $path = $datadirectory . '/knowledgebasedata/categories/category_'.$this->categoryid;
            }elseif($this->uploadfor == 'agent'){
                $path = $datadirectory . '/staffdata/staff_'.$this->staffid;
            }

            $userpath = $path . '/' . $foldername;
            $array = array(
                'path'   => $dir['basedir'] . '/' . $userpath,
                'url'    => $dir['baseurl'] . '/' . $userpath,
                'subdir' => '/'. $userpath,
            ) + $dir;
            return $array;
        }elseif($this->uploadfor == 'notificationlogo'){
            $datadirectory = jssupportticket::$_config['data_directory'];
            $path = $datadirectory;
            return $path;

        }else{
            return $dir;
        }
    }

    function storeTicketAttachment($data, $caller){
        $ticketid = $data['ticketid'];
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->ticketid = $ticketid;
        $this->uploadfor = 'ticket';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $files = $_FILES['filename'];

        if(!is_array($files['name'])){
            return;
        }

        foreach ($files['name'] as $key => $value) {
            if ($files['name'][$key]) {
                $file = array(
                        'name'     => $files['name'][$key],
                        'type'     => $files['type'][$key],
                        'tmp_name' => $files['tmp_name'][$key],
                        'error'    => $files['error'][$key],
                        'size'     => $files['size'][$key]
                        );
                $uploadfilesize = $file['size'] / 1024; //kb
                if($uploadfilesize > $filesize){
                    JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
                    return;
                }
                $filetyperesult = wp_check_filetype($_FILES['filename']['name'][$key]);
                if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
                    $document_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
                    if(stristr($document_file_types, $filetyperesult['ext'])){

                        $result = wp_handle_upload($file, array('test_form' => false));
                        if ( $result && ! isset( $result['error'] ) ) {
                            $filename = basename( $result['file'] );
                            $replyattachmentid = isset($data['replyattachmentid']) ? $data['replyattachmentid'] : '';
                            $result = $caller->storeTicketAttachment($ticketid, $replyattachmentid, $uploadfilesize, $filename);
                        } else {
                            /**
                             * Error generated by _wp_handle_upload()
                             * @see _wp_handle_upload() in wp-admin/includes/file.php
                             */
                            JSSTmessage::setMessage($result['error'], 'error');
                        }
                    }
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }

    function storeTicketViaEmailAttachment($idsarray,$key,$value){
        $datadirectory = jssupportticket::$_config['data_directory'];
        $maindir = wp_upload_dir();
        $path = $maindir['basedir'];
        $path = $path .'/'.$datadirectory;
        if (!file_exists($path)) { // create user directory
            JSSTincluder::getJSModel('jssupportticket')->makeDir($path);
        }
        $path = $path . '/attachmentdata';
        if (!file_exists($path)) { // create user directory
            JSSTincluder::getJSModel('jssupportticket')->makeDir($path);
        }
        $path = $path . '/ticket';
        if (!file_exists($path)) { // create user directory
            JSSTincluder::getJSModel('jssupportticket')->makeDir($path);
        }
        $query = "SELECT attachmentdir FROM `".jssupportticket::$_db->prefix."js_ticket_tickets` WHERE id = ".$idsarray[0];
        $foldername = jssupportticket::$_db->get_var($query);

        $path = $path . '/' . $foldername;
        if (!file_exists($path)) { // create user directory
            JSSTincluder::getJSModel('jssupportticket')->makeDir($path);
        }

        file_put_contents($path . '/' . $key, $value); // save the file
        return true;
    }

    function storeArticleAttachment($data, $caller){
        $id = $data['id'];
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->articleid = $id;
        $this->uploadfor = 'article';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $files = $_FILES['filename'];

        foreach ($files['name'] as $key => $value) {
            if ($files['name'][$key]) {
                $file = array(
                        'name'     => $files['name'][$key],
                        'type'     => $files['type'][$key],
                        'tmp_name' => $files['tmp_name'][$key],
                        'error'    => $files['error'][$key],
                        'size'     => $files['size'][$key]
                        );
                $uploadfilesize = $file['size'] / 1024; //kb
                if($uploadfilesize > $filesize){
                    JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
                    return;
                }

                $filetyperesult = wp_check_filetype($_FILES['filename']['name'][$key]);
                if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
                    $document_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
                    if(stristr($document_file_types, $filetyperesult['ext'])){

                        $result = wp_handle_upload($file, array('test_form' => false));
                        if ( $result && ! isset( $result['error'] ) ) {
                            $filename = basename( $result['file'] );
                            $result = $caller->storeArticleAttachmet($id , $uploadfilesize, $filename);
                        } else {
                            /**
                             * Error generated by _wp_handle_upload()
                             * @see _wp_handle_upload() in wp-admin/includes/file.php
                             */
                            JSSTmessage::setMessage($result['error'], 'error');
                        }
                    }
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }
    function storeDownloadAttachment($data, $caller){
        $id = $data['id'];
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->downloadid = $id;
        $this->uploadfor = 'download';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $files = $_FILES['filename'];

        foreach ($files['name'] as $key => $value) {
            if ($files['name'][$key]) {
                $file = array(
                        'name'     => $files['name'][$key],
                        'type'     => $files['type'][$key],
                        'tmp_name' => $files['tmp_name'][$key],
                        'error'    => $files['error'][$key],
                        'size'     => $files['size'][$key]
                        );
                $uploadfilesize = $file['size'] / 1024; //kb
                if($uploadfilesize > $filesize){
                    JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
                    return;
                }
                $filetyperesult = wp_check_filetype($_FILES['filename']['name'][$key]);
                if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
                    $document_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
                    if(stristr($document_file_types, $filetyperesult['ext'])){
                        $result = wp_handle_upload($file, array('test_form' => false));
                        if ( $result && ! isset( $result['error'] ) ) {
                            $filename = basename( $result['file'] );
                            $result = $caller->storeDownloadAttachment($id , $uploadfilesize, $filename);
                        } else {
                            /**
                             * Error generated by _wp_handle_upload()
                             * @see _wp_handle_upload() in wp-admin/includes/file.php
                             */
                            JSSTmessage::setMessage($result['error'], 'error');
                        }
                    }
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }

    function uploadCategoryLogo($id , $caller){

        if(!is_numeric($id))
            return false;
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->categoryid = $id;
        $this->uploadfor = 'category';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $file = array(
                'name'     => $_FILES['filename']['name'],
                'type'     => $_FILES['filename']['type'],
                'tmp_name' => $_FILES['filename']['tmp_name'],
                'error'    => $_FILES['filename']['error'],
                'size'     => $_FILES['filename']['size'],
                );
        $uploadfilesize = $file['size'] / 1024; //kb
        if($uploadfilesize > $filesize){
            JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
            return;
        }

        $filetyperesult = wp_check_filetype($_FILES['filename']['name']);
        if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
            $image_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');

            if(stristr($image_file_types, $filetyperesult['ext'])){

                $result = wp_handle_upload($file, array('test_form' => false));
                if ( $result && ! isset( $result['error'] ) ) {
                    $filename = basename( $result['file'] );
                    $result = $caller->storeCategoryLogo($id , $filename);
                } else {
                    /**
                     * Error generated by _wp_handle_upload()
                     * @see _wp_handle_upload() in wp-admin/includes/file.php
                     */
                    JSSTmessage::setMessage($result['error'], 'error');
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }

    function uploadStaffLogo($id , $caller){
        if(!is_numeric($id))
            return false;
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->staffid = $id;
        $this->uploadfor = 'agent';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $file = array(
                'name'     => $_FILES['filename']['name'],
                'type'     => $_FILES['filename']['type'],
                'tmp_name' => $_FILES['filename']['tmp_name'],
                'error'    => $_FILES['filename']['error'],
                'size'     => $_FILES['filename']['size'],
                );
        $uploadfilesize = $file['size'] / 1024; //kb
        if($uploadfilesize > $filesize){
            JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
            return;
        }
        $filetyperesult = wp_check_filetype($_FILES['filename']['name']);
        if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
            $image_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
            if(stristr($image_file_types, $filetyperesult['ext'])){

                $result = wp_handle_upload($file, array('test_form' => false));
                if ( $result && ! isset( $result['error'] ) ) {
                    $filename = basename( $result['file'] );
                    $result = $caller->storeStaffLogo($id , $filename);
                } else {
                    /**
                     * Error generated by _wp_handle_upload()
                     * @see _wp_handle_upload() in wp-admin/includes/file.php
                     */
                    JSSTmessage::setMessage($result['error'], 'error');
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }

    function storeTicketCustomUploadFile($id, $field){
        if(!isset($_FILES[$field])){
            return;
        }
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $filesize = jssupportticket::$_config['file_maximum_size'];
        $this->ticketid = $id;
        $this->uploadfor = 'ticket';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $file = array(
                'name'     => $_FILES[$field]['name'],
                'type'     => $_FILES[$field]['type'],
                'tmp_name' => $_FILES[$field]['tmp_name'],
                'error'    => $_FILES[$field]['error'],
                'size'     => $_FILES[$field]['size']
                );
        $uploadfilesize = $_FILES[$field]['size'] / 1024; //kb
        if($uploadfilesize > $filesize){
            JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
            return;
        }
        $filetyperesult = wp_check_filetype($_FILES[$field]['name']);
        if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
            $image_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
            if(strstr($image_file_types, $filetyperesult['ext'])){

                $result = wp_handle_upload($file, array('test_form' => false));
                if (isset( $result['error'] ) ) {
                    /**
                     * Error generated by _wp_handle_upload()
                     * @see _wp_handle_upload() in wp-admin/includes/file.php
                     */
                    JSSTmessage::setMessage($result['error'], 'error');
                }else{
                    $filename = basename( $result['file'] );
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        //to store name of custom file in params
        JSSTincluder::getJSModel('ticket')->storeUploadFieldValueInParams($id,$filename,$field);
        return;
    }

	function uploadInternalNoteAttachment($id,$field){
        if(!isset($_FILES[$field])){
            return;
        }
        $filename = '';
        $filesize = '';
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $filesize = jssupportticket::$_config['file_maximum_size'];
        $this->ticketid = $id;
        $this->uploadfor = 'ticket';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $file = array(
                'name'     => $_FILES[$field]['name'],
                'type'     => $_FILES[$field]['type'],
                'tmp_name' => $_FILES[$field]['tmp_name'],
                'error'    => $_FILES[$field]['error'],
                'size'     => $_FILES[$field]['size']
                );
        $uploadfilesize = $_FILES[$field]['size'] / 1024; //kb
        if($uploadfilesize > $filesize){
            JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
            return;
        }
        $filetyperesult = wp_check_filetype($_FILES[$field]['name']);
        if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
            $image_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
            if(strstr($image_file_types, $filetyperesult['ext'])){

                $result = wp_handle_upload($file, array('test_form' => false));
                if (isset( $result['error'] ) ) {
                    /**
                     * Error generated by _wp_handle_upload()
                     * @see _wp_handle_upload() in wp-admin/includes/file.php
                     */
                    JSSTmessage::setMessage($result['error'], 'error');
                }else{
					$filename = basename( $result['file'] );
					$filesize = $file['size'];
				}
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
		if($filename != '' && $filesize != ''){
			$array = array('filename' => $filename, 'filesize' => $filesize);
			return $array;
		}else{
			return false;
		}
	}

    function uploadDesktopNotificationLogo(){
        $filesize = jssupportticket::$_config['file_maximum_size'];
        if (!function_exists('wp_handle_upload')) {
            require_once( ABSPATH . 'wp-admin/includes/file.php' );
        }
        $this->uploadfor = 'notificationlogo';
        // Register our path override.
        add_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        // Do our thing. WordPress will move the file to 'uploads/mycustomdir'.
        $result = array();
        $file = array(
                'name'     => $_FILES['logo_for_desktop_notfication']['name'],
                'type'     => $_FILES['logo_for_desktop_notfication']['type'],
                'tmp_name' => $_FILES['logo_for_desktop_notfication']['tmp_name'],
                'error'    => $_FILES['logo_for_desktop_notfication']['error'],
                'size'     => $_FILES['logo_for_desktop_notfication']['size'],
                );
        $uploadfilesize = $file['size'] / 1024; //kb
        if($uploadfilesize > $filesize){
            JSSTmessage::setMessage(__('Error file size too large', 'js-support-ticket'), 'error');
            return;
        }
        $filetyperesult = wp_check_filetype($_FILES['logo_for_desktop_notfication']['name']);
        if(!empty($filetyperesult['ext']) && !empty($filetyperesult['type'])){
            $image_file_types = JSSTincluder::getJSModel('configuration')->getConfigValue('file_extension');
            if(stristr($image_file_types, $filetyperesult['ext'])){
                $result = wp_handle_upload($file, array('test_form' => false));
                if ( $result && ! isset( $result['error'] ) ) {
                    $filename = basename( $result['file'] );
                    $result = JSSTincluder::getJSModel('configuration')->storeDesktopNotificationLogo($filename);
                } else {
                    JSSTmessage::setMessage($result['error'], 'error');
                }
            }
        }
        // Set everything back to normal.
        remove_filter( 'upload_dir', array($this,'jssupportticket_upload_dir'));
        return;
    }

}

?>
